namespace o {
namespace core {

template<typename T>
T CHandle<T>::_Current = null;

template<typename T>
CHandle<T>::CHandle() :
	_Value(++_Current)
{
	// Warning if _Current rich 0xFFFFFFFF
}

template<typename T>
CHandle<T>::CHandle(bool NotNull) :
	_Value(NotNull ? ++_Current : null)
{
	// Warning if _Current rich 0xFFFFFFFF
}

template<typename T>
CHandle<T>::CHandle(const CHandle<T>& Handle) :
	_Value(Handle._Value)
{}

template<typename T>
bool CHandle<T>::operator==(const CHandle<T>& Handle)
{
	return _Value == Handle._Value;
}

template<typename T>
bool CHandle<T>::operator!=(const CHandle<T>& Handle)
{
	return _Value != Handle._Value;
}

template<typename T>
CHandle<T>& CHandle<T>::operator=(const CHandle<T>& Handle)
{
	this->_Value = Handle._Value;
	return *this;
}

template <typename T> 
inline CHandle<T>::operator const T() const 
{
    return _Value;
}

template <typename T> 
inline CHandle<T>::operator T() 
{
    return _Value;
}

template <typename T> 
CHandle<T> CHandle<T>::Null()
{
	return CHandle(false);
}

}//namespace core
}//namespace o
